/*globals define*/

define([
    'testsuite/qunit',
    'jquery',
    'ep/fn/video',

    '$ready!'
], function (QUnit, $, video) {

    var obj = JSON.parse('{"id":"0SclGz7j-p4","ext":"?list=PL5DlAwWnKPrhv_pGkElTph0M-jTx8whQE","url":"https://youtu.be/0SclGz7j-p4?list=PL5DlAwWnKPrhv_pGkElTph0M-jTx8whQE","src":"https://img.youtube.com/vi/0SclGz7j-p4/hqdefault.jpg"}');

    QUnit.module("ep/fn/video");

    QUnit.test("ep/fn/video - methods", function () {
        $.each(['youtubeIframe'], function (i, fn) {
            QUnit.strictEqual(
                $.isFunction(video[fn]),
                true,
                '$.isFunction(' + fn + '):'
            );
        });
    });

    QUnit.test("ep/fn/video - functionality", function () {
        var videoIframe = video.youtubeIframe(obj),
            iframeElem,
            srcAttr;

        QUnit.equal(
            videoIframe.hasClass('ep-video-container'),
            true,
            'Video container has the correct class.'
        );

        iframeElem = videoIframe.find('.ep-video-iframe');
        QUnit.equal(
            iframeElem.length,
            1,
            'Wrapper contains a video iframe.'
        );

        srcAttr = iframeElem.attr('src');
        QUnit.equal(
            RegExp(obj.id).test(srcAttr),
            true,
            'Video URL contains video id "' + obj.id + '".'
        );
        QUnit.equal(
            RegExp(obj.ext.replace(/\?/g, "\\?")).test(srcAttr),
            true,
            'Video URL contains video the extension "' + obj.ext + '".'
        );

    });
});